<?php
set_time_limit(0);  // no time limit to finish script!
require_once('config.php');
ob_start("ob_gzhandler");

// ---------------------------------------------------------------------------
// search directories:
   $dir = $internal_path;  
// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------
/*
    minimum procent of match% before accepting the finding
*/
   $min_procent = 60;  
   $mark        = 85;
/*
    minimum c64-filename.lenght that is accepted to search!
*/
   $min_filename_length = 5;
    
   
// ---------------------------------------------------------------------------

$get_internal_file = (!empty($_REQUEST['get_internal_file'])) ? $_REQUEST['get_internal_file'] : null;
if($get_internal_file)
{
  $filename = $get_internal_file;
  $filename = str_replace("\'","",$filename);
  if (file_exists($filename))
  {
    $dname = basename($filename);
    header("Content-Disposition: attachment; filename=\"$dname\"");
    header("Content-Type: application/octetstream");
    header("Content-Length: ".filesize($filename)); 
    header("Cache-Control: no-cache, must-revalidate"); 
    header("Pragma: no-cache");  
    $fp = fopen($filename,"r");
    if ($fp===false){echo "Open file error! Please contact admin! "; exit;}
    print fread( $fp, filesize($filename) );
    fclose($fp);
    exit();
  }
  else
  {
    echo "<h2>File does not exist! Please contact admin!</h2>".$filename."<br>";  
  } 
}
 
// ---------------------------------------------------------------------------
echo $html_begin;
echo "<b>Match the missing list(s) with any of you packs</b>";
$path = (!empty($_REQUEST['dir_selector'])) ? $_REQUEST['dir_selector'] : '';
$match = (!empty($_REQUEST['match_selector'])) ? $_REQUEST['match_selector'] : '';
$chk_mark = (!empty($_REQUEST['chkbox_group_abrv'])) ? ' checked ' : '';           // $matcher_group_abrv;
$chk_print = (!empty($_REQUEST['chkbox_print_on_the_fly'])) ? ' checked ' : '';

$selector_min    = (!empty($_REQUEST['selector_min'])) ? $_REQUEST['selector_min'] : $min_procent;
$selector_mark   = (!empty($_REQUEST['selector_mark'])) ? $_REQUEST['selector_mark'] : $mark;
$selector_length = (!empty($_REQUEST['selector_length'])) ? $_REQUEST['selector_length'] : $min_filename_length;

$min_procent         = $selector_min; 
$mark                = $selector_mark;
$min_filename_length = $selector_length;

if (($path<>'') AND ($match<>'') )
{
$file_wanted = file($match);
$release_name = Array();
$group_names = Array();
$release_note = Array();
$release_num = 0;
for ($i=0;$i<sizeOf($file_wanted);$i++)
{
  $line = trim($file_wanted[$i]);
  if ( ($line=='')  OR ($i==0) OR ($line[0]=='*') )
  {
    // Escaping: Empty lines, comment lines and first line ...
  }  
  else
  {
    if ($line[0]=='#')
    {
      // new group is found!
      $group  = strtok($line, "|");   
      $group  = substr($group,1,strlen($group)-1);
      $search = ltrim(strtok(' ')); // Get next token
      if ( (strlen($search)>1) AND (strlen($group)>1) )
        {
          $search_string .= $search." ";
          array_push($group_names,$group);
          $release_name[sizeOf($group_names)-1] = Array(); // This group's releases -
          $release_note[sizeOf($group_names)-1] = Array(); // and the releases comments
          // echo "<b>|".$group."|-|".$search."|</b><br>";
        }     
      }
    else
      {
        // releaselist of group comes now:
        $release = trim(strtoupper(strtok($line, '|'))); // Release name
        if ( (strlen($search)>1) AND ($release<>'') AND (strlen($group)>1))
        {
          // put new release to group list!
          array_push($release_name[sizeOf($group_names)-1], $release);        
          $note = ltrim(strtok(''));
          array_push($release_note[sizeOf($group_names)-1], $note);
          $release_num++;
          // echo "*".$release."*<br>";
        }
      }
  }  
}
trim($search_string);
}
echo "<form name='form' action='$PHP_SELF' style='display:inline;' method='POST'>";
echo "<br><br><b>Procent match > $min_procent%, marking: $mark%, min_filename_length: $min_filename_length</b></br>";

$selected = ($own_wanted_file<>'') ? " selected " : " ";
$show_dir  = "<SELECT name=match_selector>";
$show_dir .= "<OPTION value=\"$tdd\">Digital Dungeon</OPTION>";
$show_dir .= "<OPTION value=\"$c64heaven\">C64heaven.com</OPTION>";
$show_dir .= "<OPTION $selected value=\"$own_wanted_file\">Own wanted list</OPTION>";
$show_dir .= "</SELECT> <i>(Which wanted list to use)</i><br>";

$show_dir .= "<SELECT name=selector_min>";
$show_dir .= "<OPTION value=\"0\" disabled >min%</OPTION>";
$selected = ($selector_min==60) ? " selected " : " ";
$show_dir .= "<OPTION value=\"60\" $selected >60%</OPTION>";
$selected = ($selector_min==70) ? " selected " : " ";
$show_dir .= "<OPTION value=\"70\" $selected >70%</OPTION>";
$selected = ($selector_min==80) ? " selected " : " ";
$show_dir .= "<OPTION value=\"80\" $selected >80%</OPTION>";
$show_dir .= "</SELECT>";

$show_dir .= "<SELECT name=selector_mark>";
$show_dir .= "<OPTION value=\"0\" disabled >mark%</OPTION>";
$selected = ($selector_mark==85) ? " selected " : " ";
$show_dir .= "<OPTION value=\"85\" $selected >85%</OPTION>";
$selected = ($selector_mark==90) ? " selected " : " ";
$show_dir .= "<OPTION value=\"90\" $selected >90%</OPTION>";
$selected = ($selector_mark==95) ? " selected " : " ";
$show_dir .= "<OPTION value=\"95\" $selected >95%</OPTION>";
$show_dir .= "</SELECT>";

$show_dir .= "<SELECT name=selector_length>";
$show_dir .= "<OPTION value=\"0\" disabled >#chars</OPTION>";
$selected = ($selector_length==3) ? " selected " : " ";
$show_dir .= "<OPTION value=\"3\" $selected >3</OPTION>";
$selected = ($selector_length==4) ? " selected " : " ";
$show_dir .= "<OPTION value=\"4\" $selected >4</OPTION>";
$selected = ($selector_length==5) ? " selected " : " ";
$show_dir .= "<OPTION value=\"5\" $selected >5</OPTION>";
$selected = ($selector_length==6) ? " selected " : " ";
$show_dir .= "<OPTION value=\"6\" $selected >6</OPTION>";
$selected = ($selector_length==8) ? " selected " : " ";
$show_dir .= "<OPTION value=\"8\" $selected >8</OPTION>";
$selected = ($selector_length==10) ? " selected " : " ";
$show_dir .= "<OPTION value=\"10\" $selected >10</OPTION>";
$show_dir .= "</SELECT> <i>(MinMatch%, Mark%, MinChars#)</i><BR>";

$show_dir .= "<SELECT name=dir_selector>";
$show_dir .= "<OPTION value=''>Choose pack</OPTION>";
$show_dir .= "<OPTION value='$dir'>Search all</OPTION>";
if (is_dir($dir)) 
{
  $dir_list = scandir($dir);
  ignorecasesort($dir_list);
  for ($i=0;$i<sizeOf($dir_list);$i++)
   {
    $dir_entry = $dir_list[$i];
    if ($dir_entry != "." && $dir_entry != ".." && (is_dir($dir.$dir_entry)))  
    {
      $selected = ($path==($dir.$dir_entry.'/')) ? ' selected ' : ' ';          
      $show_dir .= "<OPTION value=\"$dir$dir_entry/\" $selected>$dir_entry</OPTION>";
    }
   }
}
$show_dir .= "</SELECT> <i>(Where to search)</i><br>";
$show_dir .= "<input type=checkbox name=chkbox_group_abrv $chk_mark >Group abbrevation must match.<br>";
$show_dir .= "<input type=checkbox name=chkbox_print_on_the_fly $chk_print >Print out results on the fly.";
echo $show_dir;
echo "<br><input type=submit name=find value='Match'>";
echo "<BR><i>- Expect some processing time for the matcher!</i><br>";
echo "<b>Please upload missings found to: <a href='ftp://ftp.scs-trc.net/pub/c64/incoming/'>ftp://ftp.scs-trc.net/pub/c64/incoming/</a></b><br>";
if($search_string)
{ 
  ob_flush();flush();sleep(1);
  // remove bad stuff from search_string
  $search_string = trim(str_replace('"', "'", $search_string));
  
  //  
  $search_string = preg_replace('/\[/','\[',$search_string); 
  $search_string = preg_replace('/\]/','\]',$search_string);
  
  $search_string = preg_replace('/\>/','\>',$search_string);
  $search_string = preg_replace('/\</','\<',$search_string);
  
  $search_string = preg_replace('/\(/','\(',$search_string);
  $search_string = preg_replace('/\)/','\)',$search_string);
  
  $search_string = preg_replace('/\+/','\+',$search_string);
  $search_string = preg_replace('/\?/','\?',$search_string);
  $search_string = preg_replace('/\*/','',$search_string);
  $search_string = preg_replace('/\$/','',$search_string);
 
  $search_strings = explode(" ", $search_string); // create array from string!
  
  function match($search_str, $filename, $c64_filename, $c64_filetype, $blocks, $md5hash)
  {
    global $DB;
    global $stack;
    global $release_name;
    global $release_note;
    global $group_names;
    global $min_procent;
    global $min_filename_length;
    global $mark;
    global $chk_mark;
    global $chk_print;
    
    // dont scan entry names that has less that MIN_FILENAME_LENGTH 'good' chars
    if (strlen(preg_replace('/[^A-Z0-9]/','',$c64_filename))>$min_filename_length)
    {
      $c64_filename = str_replace('"',"",$c64_filename);             // remove " chars in filenames
      $c64_filename_original = $c64_filename;
      
      // Remove stupid naming-styles 
      $c64_filename = reduce_entry_name($c64_filename);
      
      for ($j=0;$j<sizeOf($search_str);$j++)
          {                      
            // Group Abbrv MUST exist in filename
          if (eregi($search_str[$j], $c64_filename))   // $search_str[$j] = group abbrv.
           {
             // Check if the groupname is inside the release-name, or apart of it!
             $undo = str_replace('\\','',$search_str[$j]); 
             $pos  = strripos($c64_filename, $undo);
             // echo $c64_filename."**".$undo."--".$search_str[$j]."<br>";             
             if ( (is_int($pos)) AND (!is_az($c64_filename, $pos, strlen($undo))) )
             {        
              // remove GROUP TAG:   e.g. "[DG]", "/", DG, <DG>, (DG)
              $c64_filename_reduced = str_replace(array("/".$search_str[$j], $search_str[$j], $undo, "/", "[", "]", "(", ")", "<", ">"), "", $c64_filename );

              // Fix trainer value... "+++" -> "3+", "+  +  " -> "+2" etc..
              $c64_filename_reduced = preg_replace("/(\+){2,}/e", "\"$1\".strlen(\"$0\")", $c64_filename_reduced);
 
              for ($z=0;$z<sizeOf($release_name[$j]);$z++)
              {              
                // Match abbreviations better "Street Fighter" === "S.Fighter" etc
                $releasename = check($release_name[$j][$z], $c64_filename_reduced);
                similar_text($c64_filename_reduced, $releasename, $p);

                if ($p>$min_procent)
                { 
                  $color = $p>$mark ? " style='background-color:#00ff00;'" : ''; 
                  $disk = $DB->get_file_from_disk_md5($md5hash, $c64_filename_original);
                  $comment_edit = ($disk==false) ? " <i>File-entry not found in Spunk</i> " : "<form name=form_upd_comment><input style='text-align:right;' type=text name=i_comment size=25 value='".$disk['file_comment']."'>
                    <input type=button name=upd_comment value='save' onclick=\"javascript: SaveComment(i_comment.value, ".$disk['file_id'].")\"></form>";

                  if ($chk_print)
                  {                  
                    echo "<tr $color ><td><a target=_BLANK href=\"$PHP_SELF?get_internal_file='$filename'\">".HTML_code($c64_filename)."</a></td><td align=right>".$blocks."</td><td style='text-align:center'>".$c64_filetype."</td><td><a href='#' onClick=\"window.open('view_d64.php?filename=$filename','c64 viewer','toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=no,width=400,height=500'); return false;\">view</a></td><td>".$release_name[$j][$z]." / ".$search_str[$j]." (".$group_names[$j].") </td><td><i>&nbsp;".$release_note[$j][$z]."&nbsp;</i></td><td>".$comment_edit."</td><td>(".round($p,0)."%)</td></tr>";
                    ob_flush();flush();// sleep(1);
                  }
                  else
                  {
                    array_push($stack[$j],"<tr $color ><td><a target=_BLANK href=\"$PHP_SELF?get_internal_file='$filename'\">".HTML_code($c64_filename)."</a></td><td align=right>".$blocks."</td><td style='text-align:center'>".$c64_filetype."</td><td><a href='#' onClick=\"window.open('view_d64.php?filename=$filename','c64 viewer','toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=no,width=400,height=500'); return false;\">view</a></td><td>".$release_name[$j][$z]."</td><td><i>&nbsp;".$release_note[$j][$z]."&nbsp;</i></td><td style='text-align:right'>".$comment_edit."</td><td>(".round($p,0)."%)</td></tr>");
                  }
                }             
              } 
             }
            }         
            // Check if filename matches witout use of group abbrv.
            elseif ($chk_mark=='')
            {
              for ($z=0;$z<sizeOf($release_name[$j]);$z++)
              {              
                $releasename = check($release_name[$j][$z].$search_str[$j], $c64_filename_reduced);
                similar_text($c64_filename, $releasename, $p);

                if ($p>$min_procent)
                {                
                  $color = $p>$mark ? " style='background-color:#c0ffc0;'" : ''; 
                  $disk = $DB->get_file_from_disk_md5($md5hash, $c64_filename_original);
                  $comment_edit = ($disk==false) ? " <i>File-entry not found in Spunk</i> " : "<form name=form_upd_comment><input style='text-align:right;' type=text name=i_comment size=25 value='".$disk['file_comment']."'>
                    <input type=button name=upd_comment value='save' onclick=\"javascript: SaveComment(i_comment.value, ".$disk['file_id'].")\"></form>";

                  if ($chk_print)
                  {
                    echo "<tr $color ><td><a target=_BLANK href=\"$PHP_SELF?get_internal_file='$filename'\">".HTML_code($c64_filename)."</a></td><td align=right>".$blocks."</td><td style='text-align:center'>".$c64_filetype."</td><td><a href='#' onClick=\"window.open('view_d64.php?filename=$filename','c64 viewer','toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=no,width=400,height=500'); return false;\">view</a></td><td>".$release_name[$j][$z]." / ".$search_str[$j]." (".$group_names[$j].") </td><td><i>&nbsp;".$release_note[$j][$z]."&nbsp;</i></td><td style='text-align:right'>".$comment_edit."</td><td>(".round($p,0)."%)</td></tr>";
                    ob_flush();flush(); //sleep(1);
                  }
                  else
                  {
                    array_push($stack[$j],"<tr $color ><td><a target=_BLANK href=\"$PHP_SELF?get_internal_file='$filename'\">".HTML_code($c64_filename)."</a></td><td align=right>".$blocks."</td><td style='text-align:center'>".$c64_filetype."</td><td><a href='#' onClick=\"window.open('view_d64.php?filename=$filename','c64 viewer','toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=no,width=400,height=500'); return false;\">view</a></td><td>".$release_name[$j][$z]."</td><td><i>&nbsp;".$release_note[$j][$z]."&nbsp;</i></td><td style='text-align:right'>".$comment_edit."</td><td>(".round($p,0)."%)</td></tr>");
                  }
                }             
              }                    
            }
        }
    } 
  }  
  
  
  function searchdisk($filename, $search_str, $file_size, $md5hash)
  {
    global $stack;
    global $release_name;
    global $release_note;
    global $min_procent;
    global $min_filename_length;
    global $mark;
    
    if ( ($file_size>=174848) )
    {    
     $fp = fopen($filename,'r');
     fseek($fp,91649); // = 256*21*17 + 1 + header
     for($i=0;$i<144;$i++)
     {
      $entry = fread($fp,32);
      $file_info = unpack("Cfiletype", substr($entry, 1, 1));
      switch ($file_info["filetype"]) 
        {
          case 130: $c64_filetype = 'PRG';break; // $82             
          case 192: $c64_filetype = 'DEL';break; // 
          case 193: $c64_filetype = 'PRG';break; // 
          case 194: $c64_filetype = 'PRG';break; //            
          case 128: $c64_filetype = 'DEL';break; // $80
          case 129: $c64_filetype = 'SEQ';break; // $81
          case 131: $c64_filetype = 'USR';break; // $83
          case 132: $c64_filetype = 'REL';break; // $84
          case 0  : $c64_filetype = '*RM';break; // $00 Deleted file!
          default: $c64_filetype = 'UNK'; // Unknown              
        }      
      if ($c64_filetype<>'UNK')
      {
        $file_info = unpack("Cfilesize", substr($entry, 29, 1));
        $file_sizeB = $file_info["filesize"];

        $c64_filename = substr($entry,4,16);
        match($search_str, $filename, $c64_filename, $c64_filetype, $file_sizeB, $md5hash);
      }
     }
     fclose($fp);
    }
  }
  
  
  function searchdisk81($filename,$search_str, $md5hash)
  {
    global $stack;
    global $release_name;
    global $release_note;
    global $min_procent;
    global $min_filename_length;
    global $mark;   

    $fp = fopen($filename,'r');
    fseek($fp,400129); // (256*39*40)+(256*3)+1
    for($i=0;$i<296;$i++) //296
    {
      $entry = fread($fp,32);
      $c64_filetype = ord(substr($entry,1,1));
      switch ($c64_filetype) 
        {
          case 130: $c64_filetype = 'PRG';break; // $82             
          case 192: $c64_filetype = 'DEL';break; // 
          case 193: $c64_filetype = 'PRG';break; // 
          case 194: $c64_filetype = 'PRG';break; //            
          case 128: $c64_filetype = 'DEL';break; // $80
          case 129: $c64_filetype = 'SEQ';break; // $81
          case 131: $c64_filetype = 'USR';break; // $83
          case 132: $c64_filetype = 'REL';break; // $84
          case 0  : $c64_filetype = '*RM';break; // $00 Deleted file!
          default: $c64_filetype = 'UNK'; // Unknown              
        }
      if ($c64_filetype<>'UNK')
      {
        $c64_filename = substr($entry,4,16);
        match($search_str, $filename, $c64_filename, $c64_filetype,'-', $md5hash);
      }
    }
    fclose($fp);
  }

  
  function searchtape($filename,$search_str, $md5hash)
  {
    global $stack;
    global $release_name;
    global $release_note;
    global $min_procent;
    global $min_filename_length;
    global $mark;
    $fp = fopen($filename,'r');
    $file_size = filesize($filename);
    $c64_image = fread($fp,$file_size);
    $header = unpack("ventries", substr($c64_image, 36, 2));
    $img_size = strlen($c64_image);
		$num_entries = (256 > $header["entries"]) ? $header["entries"] : 0; 
    for($i=0;$i<$num_entries;$i++)
    {
      $offset = (32*$i)+64;
      if ($offset>$img_size){break;}
      $file_info = unpack("Cunk/Ctype/vstart/vend", substr($c64_image, $offset, 6));
			$file_sizeB = ceil(($file_info["end"]-$file_info["start"])/254);
      
      switch ($file_info["type"])
        {
          case "130" : $c64_filetype='PRG' ; break;               
          case "2"   : $c64_filetype='*PRG' ; break;               
          case "129" : $c64_filetype='SEQ' ; break;               
          case "194" : $c64_filetype='PRG<' ; break;               
          default    : $c64_filetype='UNK'; 
        }      
      $c64_filename = trim(substr($c64_image,($offset+16),16),chr(160));
      match($search_str, $filename, $c64_filename, $c64_filetype, $file_sizeB, $md5hash);
    }
    fclose($fp); 
  }  
  
  
  function searchPC64($filename,$search_str, $md5hash)
  {
    global $stack;
    global $release_name;
    global $release_note;
    global $min_procent;
    global $min_filename_length;
    global $mark;

    $c64_filename = file_get_contents($filename,false,NULL,8,16);
    $c64_filename = trim($c64_filename,chr(160)); // remove "spaces"
    $file_size = filesize($filename);
    $blocks = ceil(($file_size-26)/254);
    
    $c64_filetype = 'PRG(p00)';  
    match($search_str, $filename, $c64_filename, $c64_filetype, $blocks, $md5hash);
  }
  
  
  function searchPRG($filename,$search_str, $md5hash)
  {
    global $stack;
    global $release_name;
    global $release_note;
    global $min_procent;
    global $min_filename_length;
    global $mark;  
    
    $c64_filename = basename(str_replace('.prg','',$filename)); // remove .PRG extension   
    $c64_filetype = 'PRG(prg)';
    $file_size = filesize($filename);
    $blocks = ceil(($file_size)/254);  
    match($search_str, $filename, $c64_filename, $c64_filetype, $blocks, $md5hash);
  }
 


  function zplit($str,$chr_val)
  {
   // takes a given string $str, and a char_value (0-255)
   // returns the (sub)string until first ord($str[$i])==$chr_val 
   $stop = false;$i= 0;$res = "";          
   while (!$stop)
   {
    $p = substr($str,$i,1);
    if (strcmp(ord($p),$chr_val)<>0) $res .= $p;
    else $stop = true;
    $i++;
    if ($i>strlen($str)) break;            
   }
   return $res;       
  }
  
  function searchLNX($filename,$search_str, $md5hash)
  {
    global $stack;
    global $mark;
    global $release_name;
    global $release_note;
    global $min_procent;
    global $min_filename_length;

    $fp = fopen($filename,'r');
    $file_size = filesize($filename);
    $c64_image = fread($fp,$file_size);

    $dir_size = zplit(substr($c64_image,96,4), '20');
    $label = zplit(substr($c64_image,100,40), 13);
    $num_entries = trim(zplit(substr($c64_image,100+strlen($label)+2,4), '13'));
    $data_offset = $dir_size * 254; // binary data begins here
    // Get dir elements          
    $dir_start = 100 + strlen($label) + strlen($num_entries) + 4;
    $offset = $dir_start;
   
    for($i=0;$i<$num_entries;$i++)
    {
       $c64_filename = zplit(substr($c64_image,$offset,16),13);  
       $offset = $offset + 16 + 1;
       $file_size_B = zplit(substr($c64_image,$offset,5),13);
       $offset = $offset + 1 + strlen($file_size_B);
       $lnx_type = zplit(substr($c64_image,$offset,6),13);
       if ($lnx_type=='P') {$c64_filetype = 'PRG';}
       else if ($lnx_type=='S') {$c64_filetype = 'SEQ';}
       else if  ($lnx_type=='R') {$c64_filetype = 'REL';}
       else {$c64_filetype = 'UNK';}

       $offset = $offset + 2;
       $LSU_byte = zplit(substr($c64_image,$offset,6),13); // last sector useage                

       $offset = $offset + 1 + strlen($LSU_byte);
       $data_offset = $data_offset + $file_size_B*254;
 
       match($search_str, $filename, $c64_filename, $c64_filetype, $file_size_B, $md5hash);
    }
    fclose($fp);
  }  


function traversedir($dir,$search) 
  {
    global $stack;
    global $md5_list;
    global $c64files_examined;
    global $Lext;
    
    $dir_list = scandir($dir);     
    for ($i=0;$i<sizeOf($dir_list);$i++)
    {
      $dir_entry = $dir_list[$i];
      if ($dir_entry != "." && $dir_entry != "..")
      {
        if (is_dir($dir.$dir_entry)) 
        {
          traversedir($dir.$dir_entry.'/',$search);
        }
        else if (is_file($dir.$dir_entry)) 
        {
          $file_extension = strtolower(substr(strrchr($dir_entry,"."),1));
          if ($Lext[$file_extension])
          {            
            $c64files_examined++;
            $filename = $path.$dir.$dir_entry;
            $fp = fopen($filename,'r');
            $file_size = filesize($filename);  
            if ($file_size>0)
            {            
              $c64_image = fread($fp,$file_size);
              $md5hash = md5($c64_image);          
            
            if (!$md5_list[$md5hash]) 
            {
              $md5_list[$md5hash]=1; 
              switch($file_extension) 
              {
               case "d64": searchdisk($dir.$dir_entry,$search, $file_size, $md5hash); break;
               case "t64": searchtape($dir.$dir_entry,$search, $md5hash ); break;
               case "lnx": searchlnx($dir.$dir_entry,$search, $md5hash);  break;
               case "p00": searchPC64($dir.$dir_entry,$search, $md5hash); break;
               case "prg": searchPRG($dir.$dir_entry,$search, $md5hash);  break;
               case "d81": searchdisk81($dir.$dir_entry,$search, $md5hash); break;            
               default: ; // do nothing!
              }              
            }
           } // filesize>0
           else
           {
             fclose($fp); // file_size==0, close file  
           }             
          }                 
        }
        else
        {
          echo "Unknown type: ".$dir.$dir_list[$i]."<br>";
        }
      }  
    } 
  }

echo "<hr>Search in ".$path."<BR>C64 wanted releases: ".$release_num."<br><br>"; 
$md5_list = Array();
$stack = array();
$c64files_examined = 0;
$tid_start = getmicrotime();
if ($chk_print)
{
    echo "<table border=1 cellspacing=0 cellpadding=0>";
    echo "<caption style='text-align:left;width:400px;'><b>Search results on: ".$search_strings[$count]."</b> (".$group_names[$count].")</caption>";
    echo "<th style='text-align:left;width:200px;'>Filename</th><th style='text-align:left;'>Filesize</th><th style='text-align:left;'>Filetype</th><th>View</th><th>Release</th><th>Note</th><th>Comments</th><th>Match</th>";   
}
for ($i=0;$i<sizeOf($search_strings);$i++)
  {
   if ($search_strings[$i]<>'')
   {
    $stack[$i] = array();
   }
  }

$Lext = array_flip(array("-", "d64", "d81", "t64", "lnx", "p00", "prg"));
traversedir($path,$search_strings);
$tid_slut = getmicrotime();

if ($chk_print)
{
  echo "</table><br><br>";
}

$count = 0;
foreach ($stack as $element) {
  if (sizeof($element)>0)
  {    
    echo "<table border=1 cellspacing=0 cellpadding=0>";
    echo "<caption style='text-align:left;width:400px;'><b>Search results on: ".HTML_code($search_strings[$count])."</b> (".$group_names[$count].")</caption>";
    echo "<th style='text-align:left;width:200px;'>Filename</th><th style='text-align:left;'>Filesize</th><th style='text-align:left;'>Filetype</th><th>View</th><th>Release</th><th>Note</th><th>Comments</th><th>Match</th>";   
    foreach ($element as $found) {
      echo $found;
    } 
    echo "</table><br><br>";
  }
  $count++;
}
$redundant = $c64files_examined - sizeOf($md5_list); 
echo "<p>Time spend on search: ".gmdate('H:i:s', ($tid_slut-$tid_start)), "<BR>"; 
echo "Files examined: ".sizeOf($md5_list)." out of ".$c64files_examined.". (redundant: ".$redundant.")";
} 

echo"</FORM>";
echo $html_end;
ob_end_flush();
?>
